package com.winhc.phoenix.example.job;

import com.mongodb.client.MongoCollection;
import com.winhc.phoenix.example.framework.es.EsFastScan;
import lombok.AllArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.bson.Document;
import org.elasticsearch.client.RestHighLevelClient;
import org.elasticsearch.search.SearchHit;
import org.springframework.data.mongodb.core.MongoTemplate;
import org.springframework.stereotype.Component;

import java.util.Arrays;
import java.util.List;
import java.util.function.Consumer;
import java.util.stream.Collectors;

/**
 * @author: XuJiakai
 * 2020/11/16 20:03
 */
@Slf4j
@Component
@AllArgsConstructor
public class EsScanJob {
    private RestHighLevelClient restHighLevelClient;
    private final MongoTemplate mongoTemplate;

    public void start() {
        MongoCollection<Document> person = mongoTemplate.getCollection("person_xjk_20201117");
        Consumer<SearchHit[]> func = list -> {
            List<Document> documents = Arrays.stream(list).map(hit -> {
                String id = hit.getId();
                Document document = new Document(hit.getSourceAsMap());
                document.put("_id", id);
                return document;
            }).collect(Collectors.toList());
//            person.insertMany(documents);
        };

        new EsFastScan(restHighLevelClient, func, "dishonest-executed-person-v2", "person").scan();
//        new EsFastScan(restHighLevelClient, func, "winhc-company-test", "company").scan();
    }

}
